<!doctype html>
<html lang="<?= Txt::trad("HEADER_HTTP") ?>">
	<head>
		<!-- AGORA-PROJECT :: UNDER THE GENERAL PUBLIC LICENSE V2 :: http://www.gnu.org -->
		<meta charset="UTF-8">
		<meta content="text/html; charset=utf-8" http-equiv="Content-Type">
		<meta http-equiv="content-language" content="<?= Txt::trad("HEADER_HTTP") ?>">
		<title><?= !empty(Ctrl::$agora->name) ? Ctrl::$agora->name : "Agora-Project" ?></title>
		<meta name="Description" content="<?= !empty(Ctrl::$agora->description) ? Ctrl::$agora->description : "Agora-Project" ?>">
		<meta name="application-name" content="Agora-Project">
		<meta name="application-url" content="https://www.agora-project.net">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<meta http-equiv="X-UA-Compatible" content="IE=Edge"><!--mode compatibilité IE-->
		<link rel="icon" type="image/gif" href="app/img/favicon.gif" />
		<!-- JQUERY & JQUERY-UI -->
		<script src="app/js/jquery-2.1.4.min.js"></script>
		<script src="app/js/jquery-ui/jquery-ui.min.js"></script>
		<link rel="stylesheet" href="app/js/jquery-ui/<?= $skinCss=="white"?"smoothness":"ui-darkness" ?>/jquery-ui.css">
		<script src="app/js/jquery-ui/datepicker-<?= Txt::trad("DATEPICKER") ?>.js"></script>	<!--lang du jquery-ui datepicker-->
		<!-- JQUERY LIGHTBOX/FANCYBOX (thumbnail + mousewheel plugins) -->
		<script type="text/javascript" src="app/js/fancybox/source/jquery.fancybox.pack.js?v=2.1.5"></script>
		<link rel="stylesheet" type="text/css" href="app/js/fancybox/source/jquery.fancybox.css?v=2.1.5" media="screen" />
		<link rel="stylesheet" type="text/css" href="app/js/fancybox/source/helpers/jquery.fancybox-thumbs.css?v=1.0.7" />
		<script type="text/javascript" src="app/js/fancybox/source/helpers/jquery.fancybox-thumbs.js?v=1.0.7"></script>
		<script type="text/javascript" src="app/js/fancybox/lib/jquery.mousewheel.pack.js?v=3.1.3"></script>
		<!-- JQUERY PLUGINS -->
		<script type="text/javascript" src="app/js/tooltipster/jquery.tooltipster.min.js"></script>
		<link rel="stylesheet" type="text/css" href="app/js/tooltipster/tooltipster.css">
		<link rel="stylesheet" type="text/css" href="app/js/tooltipster/tooltipster-shadow.css">
		<script type="text/javascript" src="app/js/toastmessage/jquery.toastmessage.js"></script>
		<link rel="stylesheet" type="text/css" href="app/js/toastmessage/toastmessage.css">
		<script src="app/js/timepicker/jquery.timepicker.min.js"></script>
		<link rel="stylesheet" type="text/css" href="app/js/timepicker/jquery.timepicker.css">
		<!-- JS & CSS DE L'AGORA -->
		<script src="app/js/common-3.1.13.js"></script><!--toujours après Jquery & plugins Jquery !!-->
		<link href="app/css/common.css?v<?= VERSION_AGORA ?>" rel="stylesheet" type="text/css">
		<link href="app/css/<?= $skinCss ?>.css?v<?= VERSION_AGORA ?>" rel="stylesheet" type="text/css">

		<!-- Parametrage Javascript, Notifications, Triggers JS, etc -->
		<script type="text/javascript">
		//navigateur obsolète (tjs en premier. faire simple "alert()")
		if(isObsoleteIE())	{alert("<?= Txt::trad("version_ie") ?>");}
		langDatepicker="<?= Txt::trad("DATEPICKER") ?>";
		labelConfirmCloseLightbox="<?= Txt::trad("confirmCloseLightbox") ?>";
		labelSpecifierLoginPassword="<?= Txt::trad("specifierLoginPassword") ?>";
		labelDateBeginEndControl="<?= Txt::trad("modif_dates_debutfin") ?>";
		labelEvtConfirm="<?= Txt::trad("CALENDAR_evenement_integrer") ?>";
		labelEvtConfirmNot="<?= Txt::trad("CALENDAR_evenement_pas_integrer") ?>";
		labelUploadMaxFilesize="<?= File::uploadMaxFilesize("error") ?>";
		valueUploadMaxFilesize=<?= File::uploadMaxFilesize() ?>;
		<?php if(defined("HOST_DOMAINE"))  {Host::footerJs();} ?>
		$(function(){
			//"userFooterHtml" n'est pas vide : "#pageFooter" prends toute la largeur. Sinon "#pageFooter" à droite (logo) pour ne pas bloquer l'accès à du contenu en bas de page
			if($("#pageFooter #userFooterHtml").html()!="")  {$("#pageFooter").css("width","100%");}
			<?php
			//Affiche les Notifs & Lance les Triggers JS (parent.reload, etc)
			foreach($msgNotif as $tmpNotif)		{echo "displayNotif(\"".addslashes($tmpNotif["message"])."\", \"".$tmpNotif["type"]."\");";}
			foreach($jsTriggers as $tmpTrigger)	{echo $tmpTrigger;}
			?>
		});
		</script>
		
		<style>
		/*Background image & Lightbox & Footer*/
		#backgroundImg		{position:fixed; z-index:-10; left:0px; top:0px; width:100%; height:100%;}
		#lightboxContent	{display:none;}
		#pageFooterShadow	{height:55px;}/*ajoute 5px de marge du #pageFooter*/
		#pageFooter			{z-index:20; position:fixed; bottom:0px; right:0px; display:table;}
		#pageFooter #userFooterHtml, #pageFooter #agoraIcon {display:table-cell; padding:5px; vertical-align:bottom; color:#bbb;}
		#pageFooter #agoraIcon				{max-width:100px; text-align:right;}
		#pageFooter #agoraIcon img			{max-height:50px;}
		#pageFooter #footerSpecialMessage	{display:inline-block; max-width:1300px; margin:0px 0px -7px -7px; background-color:#500; border-radius:5px; padding:7px; color:#ddd; font-weight:bold;}/*host*/
		</style>
	</head>

	<body>
		<!--CONTENU DES LIGHTBOX-->
		<div id="lightboxContent"></div>
		<!--BACKGROUND & HEADER MENU & CORPS DE LA PAGE-->
		<?= !empty($pathWallpaper) ? "<img src=\"".$pathWallpaper."\" id='backgroundImg' class='noPrint'>" : null ?>
		<?= $headerMenu.$mainContent ?>
		<!--ICONE AGORA DU FOOTER & FOOTER PERSONNALISE (script de stats, etc)-->
		<?php if(!empty(Ctrl::$isMainPage)){ ?>
		<div id="pageFooterShadow"></div>
		<div id="pageFooter">
			<div id="userFooterHtml"><?= !empty(Ctrl::$agora->footerHtml) ? Ctrl::$agora->footerHtml : null ?></div>
			<div id="agoraIcon"><a href="<?= $pathLogoUrl ?>" target="_blank" title="<?= $pathLogoTitle ?>"><img src="<?= CtrlMisc::pathfooterLogo() ?>"></a></div>
		</div>
		<?php } ?>
	</body>
</html>